Affected QGIS version:2.16.1 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution: invalid
Crashes QGIS or corrupls data: Copied to github as #: 23411
Description

When importing multi-part geometries the "Create single-part geometries instead of multi-part” option throws an error:

Error 7

Feature write errors:

Creation error for features from #0 to #0. Provider errors was:

PostGIS error while adding features: FEHLER: Geometry type (MultiPolygon) does not match column type (Polygon)

History

#1 - 2016-08-27 07:27 AM - Tudor Barascu

| also just encountered this issue.

Steps to reproduce:

- Download natural earth coutntries data (
http://www.naturalearthdata.com/http//www.naturalearthdata.com/download/10m/cultural/ne_10m_admin_0_countries.zip

and try to import as simple features (as multipart it works)
If you try the sqlite file http:/naciscdn.org/naturalearth/packages/natural_earth_vector.sqlite.zip it won't work for either options (create as simple or as

multipart features)
- The error is the same

#2 - 2016-10-12 08:30 AM - Sandro Santilli

- Status changed from Open to Feedback

- Assignee set to Sandro Santilli

The shapefile contains record with multi-geometries, what would you expect from the "Create single-part geometries instead of multi-part" option ?

The option is passed to QgsVectorLayerlmport which does not document the semantic of that option ("forceSinglePartGeometry Type").

Also, why is this marked as Severe/Regression ?

#3 - 2016-10-12 09:26 AM - R. R.

As far as | remember former QGIS versions have converted the multipart geometries into singlepart geometries instead of throwing an error. I'll test this
later.
#4 - 2016-10-12 11:46 AM - Sandro Santilli

Reinhard let me know what you find, and what does it mean to "convert a multipart into singlepart" (augmenting the number of records ? picking just the

first component ?)

#5 - 2016-10-14 12:11 AM - R. R.

| must have been wrong, since QGIS 2.8.1 throws the same error. To me, 'Create single-part geometries instead of multi-part' in the DB-Manager should

work in the same way as 'Multipart to singleparts' in the processing toolbox.

#6 - 2016-10-14 06:24 AM - Sandro Santilli

- Priority changed from Severe/Regression to Normal

How does "Multipart to singleparts" work, within processing ? (downgrading from Severe/Regression to Normal)

#7 - 2016-10-14 09:06 AM - R. R.

'Multipart to singleparts' converts a multipart feature with 'n' geometries to 'n' singlepart features.

#8 - 2016-10-15 12:52 AM - Sandro Santilli
I don't think "Create single-part geometries instead of multi-part” was ever meant to apply any conversion.

The "Import vector to PostGIS" processing tool might be closer, having a "Promote to multipart" switch.
Can you please try how that processing tools behave if you uncheck the "Promote to multipart” setting ?

#9 - 2017-01-02 07:20 AM - Giovanni Manghi
- Resolution set to invalid
- Status changed from Feedback to Closed

Sandro Santilli wrote:

| don't think "Create single-part geometries instead of multi-part” was ever meant to apply any conversion.

That is correct. The wording is somehow misleading, but the option work as expected:
- by default any vector is imported into a MULTI* table even if the input layer has no multipart geometries

- if the input layer has no multipart geometries then this option allows to import it into a POINT/LINESTRING/POLYGON table (not MULTI*)
- if the input layer has multipart geometries than the option cannot be used and will return the described error

Files

error_7.png 19.3 KB 2016-08-24 R.R.

2025-04-27 22



